/*
Task: Experiment
 We have several example files with different solutions (u1.c, u4.c,
u5.c) that generate random numbers and find unique numbers amount.
 Conduct an experiment where you compare these programs with different sets of numbers
(1,000, 2,000, 4,000, 8,000, etc. up to 16,384,000, 15 pieces in total). Save
times. Instead of running them manually, modify the programs so that they themselves
would run 15 times.
 Currently, unique numbers are somewhere around ~80% of the total number of numbers. Change k
value (instead of n * 2, for example, n, n / 2, n / 4, up to n / 256, 10 pieces in total).
Repeat the experiment for all these different values of k. Record times. By hand
instead of running, modify the programs to run 150 themselves order.
 Create a table (in Excel?) with the obtained times and draw a graph from them.*/
#include <stdio.h>
#include <stdlib.h>
typedef struct node{
	int key;
	struct node *left, *right;
} node_t;
//adds new element to tree or ignores if already present
node_t *add(int key, node_t *p){
	node_t *tmp;
	printf("%p: %d ", p, p != NULL ? p->key : 0);
	if(p == NULL){
		tmp = malloc(sizeof(node_t));
		if(tmp == NULL){
			printf("out of space for %d!\n\n", key);
			return NULL;
		}
		tmp->key = key;
		tmp->left = tmp->right = NULL;
		printf("added %d\n\n", key);
		return tmp;
	}
	if(p->key > key){
		printf("go left\n");
		if(p->left == NULL)
			p->left = add(key, NULL);
		else
			add(key, p->left);
	}
	if(p->key < key){
		printf("go right\n");
		if(p->right == NULL)
			p->right = add(key, NULL);
		else
			add(key, p->right);
	}
	if(p->key == key){
		printf("present %d\n\n", key);
	}
	return NULL;
}

//prints the entire tree, recursive
void print(node_t *p, int level){
	if(p == NULL)
		return;
	print(p->left, level + 1);
	printf("%*s%d\n", level * 4, "", p->key);
	//printf("(%d) %d\n", level, p->key);
	print(p->right, level + 1);
}

//frees entire tree, recursive
void freeNode(node_t *p){
	if(p == NULL)
		return;
	freeNode(p->left);
	freeNode(p->right);
	free(p);
}

int main(void){
	int n;
	printf("How many: ");
	if(scanf("%d", &n) < 1 || n < 1)
		return 0;
	printf("----------------------------------------\n\n");
	node_t *root = NULL;
	int k = n * 2;
	for(int i = 0; i < n; i++)
		if(root == NULL)
			root = add(rand() % k, NULL);
		else
			add(rand() % k, root);
	print(root, 0);
	freeNode(root);
	return 0;
}

